<template>
  <div>
    <b-alert
      v-model="showSuccess"
      class="mb-2"
      variant="success"
      dismissible
    >
      {{
        successMessage
      }}
    </b-alert>
    <b-alert
      v-model="showError"
      class="mb-2"
      variant="danger"
      dismissible
    >
      {{
        errorMessage
      }}
    </b-alert>
    <b-form @submit.prevent="changePassword">
      <b-form-group label="Current Password">
        <b-form-input
          v-model="oldPassword"
          :disabled="submitting"
          :state="$v.oldPassword.$dirty ? ($v.oldPassword.$invalid ? false : true) : null"
          placeholder="Enter your current password"
          type="password"
          @change="$v.oldPassword.$touch"
        />
        <b-form-text v-if="!$v.oldPassword.$dirty || !$v.oldPassword.$invalid" />
        <b-form-invalid-feedback v-else-if="!$v.oldPassword.required">
          Field is required.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.oldPassword.maxLength || !$v.oldPassword.minLength">
          Field must have between 4 and 64 characters.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="New Password">
        <b-form-input
          v-model="newPassword"
          :disabled="submitting"
          :state="$v.newPassword.$dirty ? ($v.newPassword.$invalid ? false : true) : null"
          placeholder="Enter a new password"
          type="password"
          @change="$v.newPassword.$touch"
        />
        <b-form-text v-if="!$v.newPassword.$dirty || !$v.newPassword.$invalid">
          Your password must contain at least 8 characters.
        </b-form-text>
        <b-form-invalid-feedback v-else-if="!$v.newPassword.required">
          Field is required.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.newPassword.minLength || !$v.newPassword.maxLength">
          Field must have between 8 and 256 characters.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.newPassword.specialCharacters">
          Field must contain at least one number and one uppercase letter.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="Cofirm New Password">
        <b-form-input
          v-model="repeatNewPassword"
          :disabled="submitting"
          :state="
            $v.repeatNewPassword.$dirty ? ($v.repeatNewPassword.$invalid ? false : true) : null
          "
          placeholder="Enter the same password"
          type="password"
          @change="$v.repeatNewPassword.$touch"
        />
        <b-form-text v-if="!$v.repeatNewPassword.$dirty || !$v.repeatNewPassword.$invalid" />
        <b-form-invalid-feedback v-else-if="!$v.repeatNewPassword.required">
          Field is required.
        </b-form-invalid-feedback>
        <b-form-invalid-feedback v-else-if="!$v.repeatNewPassword.sameAsPassword">
          Field doesn't match password.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-button
        :disabled="$v.$invalid || submitting"
        block
        type="submit"
        variant="success"
      >
        Change Password
      </b-button>
    </b-form>
  </div>
</template>

<script lang="ts">
/* eslint-disable no-unsafe-finally */
import Vue from 'vue';
import { mapGetters } from 'vuex';
import {
  maxLength, minLength, required, sameAs,
} from 'vuelidate/lib/validators';

import { AuthService } from '@/api';

export default Vue.extend({
  data() {
    return {
      errorMessage: '',
      newPassword: '',
      oldPassword: '',
      repeatNewPassword: '',
      showError: false,
      showSuccess: false,
      submitting: false,
      submitted: false,
      successMessage: '',
    };
  },

  validations: {
    newPassword: {
      minLength: minLength(8),
      maxLength: maxLength(256),
      specialCharacters: (password) => {
        if (!/[A-Z]/.test(password)) {
          return false;
        }
        if (!/\d/.test(password)) {
          return false;
        }
        return true;
      },
      required,
    },
    oldPassword: {
      required,
    },
    repeatNewPassword: {
      sameAsPassword: sameAs('newPassword'),
      required,
    },
  },

  computed: {
    ...mapGetters(['user']),
  },

  methods: {
    clear() {
      this.oldPassword = '';
      this.newPassword = '';
      this.repeatNewPassword = '';
      this.$nextTick(() => {
        this.$v.$reset();
      });
    },

    async changePassword() {
      this.submitting = true;
      try {
        await AuthService.loginFresh({
          username: this.user.username,
          password: this.oldPassword,
        });
      } catch (error) {
        this.errorMessage = `There was a problem changing your password. Please try again. If the problem persists, email ${(<any> this).ANTARES_SUPPORT_EMAIL}.`;
        try {
          if (error.response.data.error === 'invalid_client') {
            this.errorMessage = 'You entered an incorrect password. Please try again.';
          }
        } finally {
          this.showError = true;
          this.submitting = false;
          return;
        }
      }
      try {
        await AuthService.resetPassword(this.newPassword);
      } catch (error) {
        this.errorMessage = error;
        this.showError = true;
        this.submitting = false;
        return;
      }
      this.clear();
      this.successMessage = 'Successfully changed password.';
      this.showSuccess = true;
      this.submitting = false;
    },
  },
});
</script>
